package at.jku.students.heap;

import java.util.Arrays;
import java.util.Comparator;
import java.util.NoSuchElementException;

import at.jku.ssw.Iterator;
import at.jku.ssw.graphviz.DotMaker;
import at.jku.ssw.queue.PriorityQueue;

@SuppressWarnings({ "rawtypes", "unchecked" })
public class ArrayPriorityQueue extends PriorityQueue implements Cloneable {

	private final Comparator comparator;
	private Object[] values;
	private int count;

	public ArrayPriorityQueue(Comparator cmp) {
		comparator = cmp;
		values = new Object[1];
		count = 1;
	}

	private ArrayPriorityQueue(ArrayPriorityQueue other) {
		comparator = other.comparator;
		values = Arrays.copyOf(other.values, other.values.length);
		count = other.count;
	}

	@Override
	protected ArrayPriorityQueue clone() {
		return new ArrayPriorityQueue(this);
	}

	public String makeDot() {
		return DotMaker.makeDotForHeap(Arrays.copyOf(values, count));
	}

	@Override
	public String toString() {
		if (size() == 0) {
			return "[]";
		}
		StringBuilder sb = new StringBuilder();
		sb.append('[');

		Iterator it = iterator();
		assert it.hasNext();
		sb.append(it.next());

		while (it.hasNext()) {
			sb.append(", ");
			sb.append(it.next());
		}
		sb.append(']');
		return sb.toString();
	}

	@Override
	public void push(Object value) {
		// TODO
	}

	@Override
	public Object take() {
		// TODO
		return null;
	}

	@Override
	public Object peek() {
		// TODO
		return null;
	}

	@Override
	public boolean contains(Object value) {
		// TODO
		return false;
	}

	@Override
	public boolean remove(Object value) {
		// TODO
		return false;
	}

	@Override
	public int size() {
		// TODO
		return -1;
	}

	@Override
	public Iterator iterator() {
		// TODO
		return null;
	}
}
